%define version	1.6.8
%define release	%mkrel 4

%define major_version 1.6
%define libname %mklibname %{name} 12

# (Abel) making guile require guile-devel means user need to download
# more stuff, which is worse
%define _requires_exceptions devel(.*)

Summary:	A GNU implementation of Scheme for application extensibility
Name:		guile
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		Development/Other
URL:		http://www.gnu.org/software/guile/guile.html
Buildroot:	%{_tmppath}/%{name}-%{version}-%{release}-root

Source0:	ftp://ftp.gnu.org/pub/gnu/guile-%{version}.tar.gz
Source1:	ftp://ftp.gnu.org/pub/gnu/guile-%{version}.tar.gz.sig
Patch1:		guile-1.6.0-64bit-fixes.patch.bz2
Patch2:		guile-1.6.4-amd64.patch.bz2
Patch3:		guile-1.6.7-gcc4.patch.bz2

Requires(post):		umb-scheme > 3.2-23mdk
Requires(post):		%{libname} = %{version}-%{release}
Requires(post):		info-install
Requires(preun):	info-install
BuildRequires:	libltdl-devel
BuildRequires:	ncurses-devel
BuildRequires:	readline-devel

# for "make check" srfi-19.test
BuildRequires:	timezone

%package -n %{libname}
Summary:	Libraries for Guile %{version}
Group:		System/Libraries
Requires:	%{name} = %{version}

%package -n %{libname}-devel
Summary:	Development headers and static library for libguile
Group:		Development/C
Requires:	%{libname} = %{version}
Provides:	libguile-devel = %{version}-%{release}
Provides:	guile-devel = %{version}-%{release}
Obsoletes:	guile-devel
Requires:	libtool-devel

# (Abel) here comes the definition of "ugliness"
%ifarch x86_64 ia64 amd64 sparc64 ppc64
Requires:	devel(libcrypt(64bit))
Requires:	devel(libdl(64bit))
Requires:	devel(libguile-ltdl(64bit))
Requires:	devel(libm(64bit))
#i (misc) removed, no quickthread on 64 bit
#Requires:	devel(libqthreads(64bit))
%else
Requires:	devel(libcrypt)
Requires:	devel(libdl)
Requires:	devel(libguile-ltdl)
Requires:	devel(libm)
%ifnarch ppc x86_64
Requires:	devel(libqthreads)
%endif
%endif

%description
GUILE (GNU's Ubiquitous Intelligent Language for Extension) is a
library implementation of the Scheme programming language, written in
C.  GUILE provides a machine-independent execution platform that can
be linked in as a library during the building of extensible programs.

Install the guile package if you'd like to add extensibility to
programs that you are developing.  You'll also need to install the
guile-devel package.

%description -n %{libname}
This package contains Guile shared object libraries and the ice-9
scheme module. Guile is the GNU Ubiquitous Intelligent Language for
Extension.

%description -n %{libname}-devel
This package contains the development headers and the static library
for libguile. C headers, aclocal macros, the `guile1.4-snarf' and
`guile-config' utilities, and static `libguile' library for Guile, the
GNU Ubiquitous Intelligent Language for Extension

%prep
%setup -q
%patch1 -p1 -b .64bit-fixes
%patch2 -p1 -b .amd64
%patch3 -p1 -b .gcc4

%build
%configure2_5x --enable-dynamic-linking --with-threads
%make LIBTOOL=libtool

%ifarch ia64
# FAIL: r4rs.test: (6 9): (#<procedure leaf-eq? (x y)> (a (b (c))) ((a) b c))
make check -k || :
%else
# all tests must pass
make check
%endif

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std

install -d $RPM_BUILD_ROOT%{_datadir}/guile/site
ln -s ../../share/umb-scheme/slib $RPM_BUILD_ROOT%{_datadir}/guile/slib
#gw needed with guile 1.6.8 and new slib
ln -s %_datadir/umb-scheme/slib %buildroot%_datadir/guile/%major_version/slib

%multiarch_includes $RPM_BUILD_ROOT%{_includedir}/libguile/scmconfig.h

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post
%{_bindir}/guile -c "(use-modules (ice-9 slib)) (require 'new-catalog)"
%_install_info guile-tut.info
%_install_info guile.info
%_install_info r5rs.info
%_install_info goops.info

%preun
%_remove_install_info guile-tut.info
%_remove_install_info guile.info
%_remove_install_info r5rs.info
%_remove_install_info goops.info

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS COPYING NEWS README THANKS
%{_bindir}/guile
%{_bindir}/guile-tools
%{_datadir}/guile
%{_infodir}/*
%{_libdir}/libguile-srfi-srfi-13-14-v-1.so
%{_libdir}/libguile-srfi-srfi-4-v-1.so
%{_libdir}/libguilereadline-v-12.so

%files -n %{libname}
%defattr(-,root,root)
%doc libguile/ChangeLog*
%{_libdir}/lib*.so.*

%files -n %{libname}-devel
%defattr(-,root,root)
%doc ANON-CVS ChangeLog HACKING SNAPSHOTS
%{_bindir}/guile-config
%{_bindir}/guile-snarf
%{_libdir}/lib*.*a
%{_libdir}/libguile-ltdl.so
%{_libdir}/libguile.so
%ifnarch ppc x86_64
%{_libdir}/libqthreads.so
%endif
%{_datadir}/aclocal/*
%{_includedir}/libguile*
%{_includedir}/guile*
%multiarch %{multiarch_includedir}/libguile/scmconfig.h

%changelog
* Mon Sep 18 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.6.8-4mdv2007.0
- Rebuild

* Tue Aug  8 2006 Götz Waschk <waschk@mandriva.org> 1.6.8-3mdv2007.0
- add slib symlink
- bump umb-scheme dep

* Mon Aug  7 2006 Götz Waschk <waschk@mandriva.org> 1.6.8-2mdv2007.0
- fix post installation script

* Mon Aug 07 2006 Götz Waschk <waschk@mandriva.org> 1.6.8-1mdv2007.0
- New release 1.6.8


* Wed Mar 08 2006 Michael Scherer <misc@mandriva.org> 1.6.7-9mdk
- fix requires on x86_64 ( no quick thread )
- do use file based requires

* Wed Jan 18 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.6.7-8mdk
- fix build for x86-64 - no qthreads

* Tue Oct 11 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.6.7-7mdk
- fix file list and deps for ppc - no quickthreads

* Thu Aug 25 2005 Abel Cheung <deaddog@mandriva.org> 1.6.7-6mdk
- Move some .so symlinks to main package as they are dynamically loaded
  by *.scm files (#13837)
- Prereq -> Requires (#17444)

* Sat Aug 20 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.6.7-5mdk
- add BuildRequires: libltdl-devel

* Fri Aug 19 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.6.7-4mdk
- gcc4 fixes

* Thu Feb 03 2005 Abel Cheung <deaddog@mandrake.org> 1.6.7-3mdk
- multiarch
- Fix info-install requirement

* Fri Jan 21 2005 Götz Waschk <waschk@linux-mandrake.com> 1.6.7-2mdk
- rebuild for new readline

* Sun Dec 26 2004 Abel Cheung <deaddog@mandrake.org> 1.6.7-1mdk
- New release
- Use tar.gz (with signature)
- Move shared files out of lib package, allowing multilib

* Thu Aug 28 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.6.4-3mdk
- Patch2: Add AMD64 support from boehm-gc

* Thu Aug 14 2003 Pixel <pixel@mandrakesoft.com> 1.6.4-2mdk
- distlint DIRM fix: /usr/share/guile is now owned by libguileXX

* Thu Aug  7 2003 Pixel <pixel@mandrakesoft.com> 1.6.4-1mdk
- new release
- use %%mklibname
- fix calls to %%_install_info

* Fri Jul 11 2003 Frederic Crozat <fcrozat@mandrakesoft.com> - 1.6.0-5mdk
- Rebuild for latest provides

* Sun Jun  8 2003 Stefan van der Eijk <stefan@eijk.nu> - 1.6.0-4mdk
- BuildRequires

* Thu Jun  5 2003 Frederic Crozat <fcrozat@mandrakesoft.com> - 1.6.0-3mdk
- Rebuild to get new deps

* Tue Apr 22 2003 Frederic Crozat <fcrozat@mandrakesoft.com> - 1.6.0-2mdk
- Fix devel dependency

* Tue Dec  3 2002 Pixel <pixel@mandrakesoft.com> 1.6.0-1mdk
- new release
- cleanup (eg: do include guile-procedures.txt, why was it excluded??)

* Tue Dec  3 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.4.1-2mdk
- Use system libtool

* Tue Dec  3 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.4.1-1mdk
- Version 1.4.1 for 9.0-branch, make it lib64 aware, parallel build works
- Default to make check in %%build, all tests must pass
- Patch0: Don't use obsolete filename_completion_function() from readline
- Patch1: Various fixes for 64-bit architectures
- Patch2: Add support for IA-64 backing store (CVS)

* Wed Jul 24 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 1.4-15mdk
- Disable parallel compilation, it is broken
- Recompiled with latest readline

* Wed Aug  8 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.4-14mdk
- Move ice-9 files to libguile9 (gc)

* Tue Aug  7 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.4-13mdk
- Libification

* Thu May 31 2001 Renaud Chaillat <rchaillat@mandrakesoft.com> 1.4-12mdk
- added version number to umb-scheme requirement

* Wed May 30 2001 Renaud Chaillat <rchaillat@mandrakesoft.com> 1.4-11mdk
- slib link now points to datadir not libdir (see modifications in umb-scheme)

* Tue Mar 26 2001 David BAUDENS <baudens@mandrakesoft.com> 1.4-10mdk
- PPC: Add -O2 to CFLAGS to prevent some strange crashes

* Sat Mar 24 2001 David BAUDENS <baudens@mandrakesoft.com> 1.4-9mdk
- PPC: use default flags
- Use macros
- Use %%_tmppath for BuildRoot
- Bzip2 patch

* Mon Jan 29 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.4-8mdk
- specific CFLAGS for PowerPC

* Wed Nov 15 2000 Egil Moeller <redhog@mandrakesoft.com> 1.4-7mdk
- Bugworkaround around the flawed Makefile.

* Mon Sep 11 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.4-6mdk
- ooops wrong info file name.

* Mon Sep 11 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.4-5mdk
- finalized BM (Thanks Stefan).

* Fri Sep  8 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.4-4mdk
- removed menu entry.
- added a depency for guile-devel on guile with the same release.

* Mon Aug 07 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.4-3mdk
- automatically added BuildRequires

* Fri Jul 21 2000 Pixel <pixel@mandrakesoft.com> 1.4-2mdk
- add provides libguile.so.6

* Tue Jul 11 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.4-1mdk
- 1.4

* Thu Mar 30 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.3.4-3mdk
- fix group

* Sun Nov  7 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- provides libguile.so.[15].

* Fri Nov 05 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- SMP build/check
- 1.3.4

* Tue Aug 31 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- added macro %%{guilever} as apckage version is 1.3.2a but
  for paths, etc. it remains 1.2.3
- corrected %files section (some libs weren't included)

* Thu Aug 26 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- -1.3.2a

* Fri Apr 23 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Mandrake adaptations.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 6)

* Wed Mar 17 1999 Michael Johnson <johnsonm@redhat.com>
- added .ansi patch to fix #endif

* Wed Feb 10 1999 Cristian Gafton <gafton@redhat.com>
- add patch for the scm stuff

* Sun Jan 17 1999 Jeff Johnson <jbj@redhat.com>
- integrate changes from rhcn version (#640)

* Tue Jan 12 1999 Cristian Gafton <gafton@redhat.com>
- call libtoolize first to get it to compile on the arm

* Sat Jan  9 1999 Todd Larason <jtl@molehill.org>
- Added "Requires: guile" at suggestion of Manu Rouat <emmanuel.rouat@wanadoo.fr>

* Fri Jan  1 1999 Todd Larason <jtl@molehill.org>
- guile-devel does depend on guile
- remove devel dependancy on m4
- move guile-snarf from guile to guile-devel
- Converted to rhcn

* Wed Oct 21 1998 Jeff Johnson <jbj@redhat.com>
- update to 1.3.
- don't strip libguile.so.*.0.0. (but set the execute bits).

* Thu Sep 10 1998 Cristian Gafton <gafton@redhat.com>
- spec file fixups

* Wed Sep  2 1998 Michael Fulbright <msf@redhat.com>
- Updated for RH 5.2

* Mon Jan 26 1998 Marc Ewing <marc@redhat.com>
- Started with spec from Tomasz Koczko <kloczek@idk.com.pl>
- added slib link

* Thu Sep 18 1997 Tomasz Koczko <kloczek@idk.com.pl>          (1.2-3)
- added %attr(-, root, root) for %doc, 
- in %post, %postun ldconfig runed as parameter "-p",
- removed /bin/sh from requires,
- added %description,
- changes in %files.

* Fri Jul 11 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>  (1.2-2)
- all rewrited for using Buildroot,
- added %postun,
- removed making buid logs,
- removed "--inclededir", added "--enable-dynamic-linking" to configure
  parameters,
- added striping shared libs and /usr/bin/guile,
- added "Requires: /bin/sh" (for guile-snarf) in guile package and
  "Requires: m4" for guile-devel,
- added macro %{PACKAGE_VERSION} in "Source:" and %files,
- added %attr macros in %files.
